#!/usr/bin/perl --

#################################################################################################
# ShoutDisplay.pl:   Part of the Shoutbox Mod                                                   #
# Copyright:         2005 Andrew Aitken (LoonyPandora)                                          #
# Version:          Shoutbox for YaBB 2.6.0                                                     #
# Released:         14th Aug, 2014                                                              #
# Distributed by:   http://www.yabbforumsoftware.com                                            #
# Update by:        Batchman, Derek Barnstorm, D0T-C0M, Driven, Unilat, ThM with permission     #
# Update to 2.6.0 by Dandello                                                                   #
#################################################################################################

use CGI::Carp qw(fatalsToBrowser);
our $VERSION = '2.6.0';
$shoutdisplayplver = 'Shoutbox Mod for YaBB 2.6.0';

# Make sure the module path is present
# Some servers need all the subdirs in @INC too.

push @INC, './Modules';
push @INC, './Modules/Digest';

if ( $ENV{'SERVER_SOFTWARE'} =~ /IIS/sm ) {
    $yyIIS = 1;
    if ( $PROGRAM_NAME =~ m{(.*)[\\|/]}xsm ) {
        $yypath = $1;
    }
    $yypath =~ s/\\/\//gxsm;
    chdir $yypath;
    push @INC, $yypath;
}

$yyexec      = 'YaBB';
$script_root = $ENV{'SCRIPT_FILENAME'};
if ( !$script_root ) {
    $script_root = $ENV{'PATH_TRANSLATED'};
}
$script_root =~ s/\/$yyexec\.(pl|cgi)//igxsm;

$START_TIME = time;

DisplayShouts();

sub DisplayShouts {

    require Paths;
    require Variables::Settings;
    require Sources::Subs;
    require Sources::Load;
    require Sources::DateTime;
    require "$vardir/shoutsettings.txt";

    $scripturl = qq~$boardurl/YaBB.$yyext~;

    LoadLanguage('Shoutbox');
    LoadLanguage('Main');
    LoadCookie();
    LoadUser($username);

    # Determine guest and admin positions

    $iamguest = $username eq 'Guest' ? 1 : 0;
    if ( ${ $uid . $username }{'position'} eq 'Administrator' ) {
        $iamadmin = 1;
    }

######################################################
######################################################
    #This is what you want to change if you need to
    #increase the height of the bottom portion of the
    #shoutbox to accommodate more lines or taller smilies
    #The code is split into 2 sections AND you have to
    #change both sections.
######################################################
##########  FIRST SECTION  ###########################
    $px        = 'px';
    $shout_h_a = 8;
    $shout_h_b = 27;
    if ( $shout_width < 380 ) {
        $shout_text_height  = 150;
        $shout_text_height2 = $shout_text_height;

        if ( ${ $uid . $username }{'lp_shout_bbcode'} eq q{} ) {
            $shout_text_height2 -= $shout_h_a;
        }
        $shout_width = qq~$shout_width~;
        if ( ${ $uid . $username }{'lp_shout_smileys'} eq q{} ) {
            $shout_text_height2 -= $shout_h_b;
        }
        $shout_text_height3 = $shout_text_height2 + $shout_h_a;
    }
    else {
        $shout_text_height  = 110;
        $shout_text_height2 = $shout_text_height;

        if ( ${ $uid . $username }{'lp_shout_bbcode'} eq q{} ) {
            $shout_text_height2 -= $shout_h_a;
        }

        if ( ${ $uid . $username }{'lp_shout_smileys'} eq q{} ) {
            $shout_text_height2 -= $shout_h_a;
        }
        $shout_text_height3 = $shout_text_height2 + $shout_h_a;
    }

    $shout_text_height4 = $shout_text_height3 - 4;

    # Figure out which template to be using.

    WhatTemplate();
    LoadLanguage('Shoutbox');
    LoadLanguage('Main');
    LoadLanguage('Menu');

    if ($adminscreen) {
        LoadLanguage('Admin');
        LoadLanguage('FA');
    }

    # Guardian Form spoofing protection
    $formsession = cloak("$mbname$username");

    # Set guests censor language

    if   ($iamguest) { our $language = $censor_lang; }
    else             { $language     = ${ $uid . $username }{'language'} }

    fopen( SHOUTS, "$vardir/shouts.txt" );
    @shouts = <SHOUTS>;
    fclose(SHOUTS);

    $number_of_shouts = $#shouts;
    $skip_shouts      = ( $number_of_shouts - $max_disp_shouts );
    $counter          = 0;

    if ( ${ $uid . $username }{'reverse_post'} ) {
        @shouts = reverse @shouts;
    }

    if ( !$INFO{'showall'} ) {

        for my $shoutline (@shouts) {
            if ( $counter > $skip_shouts ) {
                chomp @shouts;
                (
                    $shout_time,     $shout_displayname,
                    $shout_username, $shout_message
                ) = split /[|]/xsm, $shoutline;

                $delete_link = q{};
                LoadLanguage('Shoutbox');
                CheckCanDelete();

                # Censor the posts, and display names
                if ($enable_censor) {
                    LoadCensorList();
                    $shout_displayname = Censor($shout_displayname);
                    $shout_message     = Censor($shout_message);
                }

                # Do UBBC on the Shout (append shout_ before vars)
                $message = $shout_message;
                wrap();
                if ($enable_ubbc) {
                    enable_yabbc();
                    DoUBBC();
                }
                my_wrap3();

                if ( $enable_limiter == 1 ) {
                    $limiter = q~<div class="small" id="shoutlimiter"></div>~;
                }

                if ( $enable_tdmouseover == 1 ) {
                    $tdmo =
qq~onmouseover="this.className='tdmouseover'" onmouseout="this.className='$class'"~;
                }

                if ( $enable_scrollbar == 1 ) {
                    $scrollbar = q~scrolling="no"~;
                }

                $shout_message = $message;

                $shout_time = timeformat($shout_time);

                # Set the alternating backgrounds colours
                if   ( $counter % 2 ) { $class = 'shout_windowbg'; }
                else                  { $class = 'shout_windowbg2'; }

                if ( ${ $uid . $username }{'lp_shout_timestamp'} ) {
                    $timestamp = "$shout_time";
                }
                if ( !${ $uid . $shout_username }{'password'} ) {
                    LoadUser($shout_username);
                }

                my $lastonline;
                if ( $iamadmin || $iamgmod || $lastonlineinlink ) {
                    $lastonline =
                      $date - ${ $uid . $shout_username }{'lastonline'};
                    my $days  = int( $lastonline / 86_400 );
                    my $hours = sprintf '%02d',
                        int( ( $lastonline - ( $days * 86_400 ) ) / 3600 );
                    my $mins = sprintf '%02d',
                        int( ( $lastonline - ( $days * 86_400 ) - ( $hours * 3600 ) ) / 60 );
                    my $secs = sprintf '%02d',
                        ( $lastonline - ( $days * 86_400 ) - ( $hours * 3600 ) - ( $mins * 60 ) );
                    if ( !$mins ) {
                        $lastonline = "00:00:$secs";
                    }
                    elsif ( !$hours ) {
                        $lastonline = "00:$mins:$secs";
                    }
                    elsif ( !$days ) {
                        $lastonline = "$hours:$mins:$secs";
                    }
                    else {
                        $lastonline = "$days $maintxt{'11'} $hours:$mins:$secs";
                    }
                    $lastonline =
                      qq~ title="$maintxt{'10'} $lastonline $maintxt{'12'}."~;
                }

                $shout_rows .= qq~
        <script type="text/javascript">
        function confirmDelete() {
        return confirm("$shout_txt{'50'}");
        }
        </script>
    <tr>
        <td class="$class" $tdmo style="font-size: 10px;">
            <div style="float:left; padding:3px;">[$timestamp]&nbsp;<a href="$scripturl?action=viewprofile;username=$useraccount{$shout_username}"$lastonline target="_parent" ${$uid.$shout_username}{'realname'}: $format{$shout_username}:</a></div>
            <div style="float:right;padding-right:3px;padding-left:3px;">$delete_link</div><div style="clear:both"></div>$shout_message
        </td>
    </tr>~;
            }
            $counter++;
        }
        $shoutform_action = "$scripturl?action=write_shouts";
        Template();

    }
    else {
        for my $shoutline (@shouts) {
            chomp @shouts;
            ( $shout_time, $shout_displayname, $shout_username, $shout_message )
              = split /[|]/xsm, $shoutline;
            $delete_link = q{};
            CheckCanDelete_showall();

            if ( length($message) > $max_shout_length ) {
                $message = substr $message, 0, $max_shout_length;
            }

            # Do UBBC on the Shout (append shout_ before vars)
            $message = $shout_message;
            wrap();
            if ($enable_ubbc) {
                enable_yabbc();
                DoUBBC();
            }
            my_wrap3();

            # Censor the posts, and display names
            if ($enable_censor) {
                LoadCensorList();
                $shout_displayname = Censor($shout_displayname);
                $shout_message     = Censor($shout_message);
            }

            if ( $enable_limiter == 1 ) {
                $limiter = q~<div class="small" id="shoutlimiter"></div>~;
            }

            if ( $enable_tdmouseover == 1 ) {
                $tdmo =
qq~onmouseover="this.className='tdmouseover'" onmouseout="this.className='$class'"~;
            }

            $shout_message = $message;

            $shout_time = timeformat($shout_time);

            # Set the alternating backgrounds colours
            if   ( $counter % 2 ) { $class = 'shout_windowbg'; }
            else                  { $class = 'shout_windowbg2'; }

            if ( ${ $uid . $username }{'lp_shout_timestamp'} ) {
                $timestamp = "$shout_time";
            }
            if ( !${ $uid . $shout_username }{'password'} ) {
                LoadUser($shout_username);
            }

            my $lastonline;
            if ( $iamadmin || $iamgmod || $lastonlineinlink ) {
                $lastonline = $date - ${ $uid . $shout_username }{'lastonline'};
                my $days  = int( $lastonline / 86_400 );
                my $hours = sprintf '%02d',
                    int( ( $lastonline - ( $days * 86_400 ) ) / 3600 );
                my $mins = sprintf '%02d',
                    int( ( $lastonline - ( $days * 86_400 ) - ( $hours * 3600 ) ) / 60 );
                my $secs = sprintf '%02d',
                    ( $lastonline - ( $days * 86_400 ) - ( $hours * 3600 ) - ( $mins * 60 ) );
                if ( !$mins ) {
                    $lastonline = "00:00:$secs";
                }
                elsif ( !$hours ) {
                    $lastonline = "00:$mins:$secs";
                }
                elsif ( !$days ) {
                    $lastonline = "$hours:$mins:$secs";
                }
                else {
                    $lastonline = "$days $maintxt{'11'} $hours:$mins:$secs";
                }
                $lastonline =
                  qq~ title="$maintxt{'10'} $lastonline $maintxt{'12'}."~;
            }

            $shout_rows .= qq~

        <script type="text/javascript">

        function confirmDelete() {
        return confirm("$shout_txt{'50'}");
        }

        </script>
    <tr>
        <td class="$class" $tdmo style="font-size: 10px;">
            <div style="float:left;padding-right:3px;padding-left:3px;">$timestamp&nbsp;<a href="$scripturl?action=viewprofile;username=$useraccount{$shout_username}"$lastonline target="_parent" ${$uid.$shout_username}{'realname'} : $format{$shout_username}:</a></div>
            <div style="float:right;padding-right:3px;padding-left:3px;">$delete_link</div><br />$shout_message
        </td>
    </tr>~;

            $counter++;
        }

        $shoutform_action = "$scripturl?action=write_shouts;showall=1";

        Template();
        if ( length($message) > $max_shout_length ) {
            $message = substr $message, 0, $max_shout_length ;
        }
    }
    return;
}

sub CheckCanDelete {
    if ( $delete_delay == 0 ) { return; }

    if ( $iamadmin || ( !$iamguest && ( $username eq $shout_username ) ) ) {
        my $now_time = int time;
        if ( ( $now_time - $shout_time ) > $delete_delay ) {
            if ( !$iamadmin || !$admin_deletion_link ) { return; }
        }
        $delete_link =
qq~<a href="$scripturl?action=useremoveshouts;shout=$shout_time;user=$shout_username" target="shouts"  onclick="return confirmDelete();"><img src="$yyhtml_root/ModImages/Shoutbox/stop.png" alt="$shout_txt{'46'}" title="$shout_txt{'47'}"></a>~;
    }
    return;
}

sub CheckCanDelete_showall {
    if ( $delete_delay == 0 ) { return; }

    if ( $iamadmin || ( !$iamguest && ( $username eq $shout_username ) ) ) {
        my $now_time = int time;
        if ( ( $now_time - $shout_time ) > $delete_delay ) {
            if ( !$iamadmin || !$admin_deletion_link ) { return; }
        }
        $delete_link =
qq~<a href="$scripturl?action=useremoveshouts;shout=$shout_time;user=$shout_username" target="_parent"  onclick="return confirmDelete();"><img src="$yyhtml_root/ModImages/Shoutbox/stop.png" alt="$shout_txt{'46'}" title="$shout_txt{'47'}"></a>~;
    }
    return;
}

sub my_wrap3 {
    $shout_message =~
s/(<.*>)*(\S{0,14})(\S{0,14})?(\S{0,14})?(\S{0,14})?(\S*)?(<.*>)*/$1$2 $3 $4 $5 $6$7/gixsm;
    $shout_message =~
s/(<.*>)?(\S{0,14})(\S{0,14})?(\S{0,14})?(\S{0,14})?(\S*)(<\/\S*>)/$1$2 $3 $4 $5 $6$7/gixsm;
    $shout_message =~ s/\s+/ /gism;
    return;
}

sub Timer {
    $time_running = time - $START_TIME;
    $time_running = sprintf '%.4f', $time_running;
    print qq~
<!-- Ran for $time_running seconds  -  Accessed $file_open files-->
~ or croak "$croak{'print'} running";
    return;
}

sub ShowExtras {

    # Multiply by 1000, because JS uses millseconds
    if ( ${ $uid . $username }{'lp_shout_refresh'} >= 10 ) {
        $refresh    = ( ${ $uid . $username }{'lp_shout_refresh'} * 1000 );
        $refresh_js = qq~
/* Scrolls page, and sets timer for autorefreshing */
    function timer() {
        window.scrollTo(0,99999);
        setTimeout("reload_page()", $refresh);
    }

/* Reloads page if message is default or blank */
    function reload_page() {
        if (document.shoutbox.message.value == "") {
            window.location.reload();
        }
    }
~;
    }
    else {
        $refresh_js = q~
/* Scrolls page, and sets timer for autorefreshing */
function timer() {
    window.scrollTo(0,99999);
    }
~;
    }
    if ( ${ $uid . $username }{'on_load_focus'} ) {
        $shoutbox_on_load_focus = q~ document.shoutbox.message.focus();~;
    }
    else { $shoutbox_on_load_focus = q{}; }

    if ( ${ $uid . $username }{'lp_shout_smileys'} ) {
        %smiley_bar = (
            'a' => "smiley.gif|smiley()|$post_txt{'287'}",
            'b' => "wink.gif|wink()|$post_txt{'292'}",
            'c' => "cheesy.gif|cheesy()|$post_txt{'289'}",
            'd' => "grin.gif|grin()|$post_txt{'293'}",
            'e' => "angry.gif|angry()|$post_txt{'288'}",
            'f' => "sad.gif|sad()|$post_txt{'291'}",
            'g' => "shocked.gif|shocked()|$post_txt{'294'}",
            'h' => "cool.gif|cool()|$post_txt{'295'}",
            'i' => "huh.gif|huh()|$post_txt{'296'}",
            'j' => "rolleyes.gif|rolleyes()|$post_txt{'450'}",
            'k' => "tongue.gif|tongue()|$post_txt{'451'}",
            'l' => "embarassed.gif|embarassed()|$post_txt{'526'}",
            'm' => "lipsrsealed.gif|lipsrsealed()|$post_txt{'527'}",
            'n' => "undecided.gif|undecided()|$post_txt{'528'}",
            'o' => "kiss.gif|kiss()|$post_txt{'529'}",
            'p' => "cry.gif|cry()|$post_txt{'530'}",
        );
        ( $smiley_bar, $boxlist1_w ) = smiley_list(%smiley_bar);

        $smiley_bar .= qq~$moresmilieslist~;
    }
    else {
        $smiley_bar = qq~<span class="small">$post_txt{'215'}</span>~;
    }

    if ( ${ $uid . $username }{'lp_shout_bbcode'} && $enable_ubbc ) {
        my %ubbcode_bar = (
            'a' => "bold.gif|bold()|$post_txt{'253'}",
            'b' => "italicize.gif|italicize()|$post_txt{'254'}",
            'c' => "underline.gif|underline()|$post_txt{'255'}",
            'd' => "strike.gif|strike()|$post_txt{'441'}",
            'e' => "move.gif|move()|$post_txt{'439'}",
            'f' => "tele.gif|teletype()|$post_txt{'440'}",
            'g' => "url.gif|url()|$post_txt{'257'}",
            'h' => "email2.gif|emai1()|$post_txt{'258'}",
        );
        ( $bbcode_bar, $boxlist1_w ) = ubbc_boxlist(%ubbcode_bar);
        $bbcode_bar .= qq~
            <script type="text/javascript">
             // Palette
            var thistask = 'post';
            function tohex(i) {
                a2 = ''
                ihex = hexQuot(i);
                idiff = eval(i + '-(' + ihex + '*16)')
                a2 = itohex(idiff) + a2;
                while( ihex >= 16) {
                    itmp = hexQuot(ihex);
                    idiff = eval(ihex + '-(' + itmp + '*16)');
                    a2 = itohex(idiff) + a2;
                    ihex = itmp;
                }
                a1 = itohex(ihex);
                return a1 + a2 ;
            }

            function hexQuot(i) {
                return Math.floor(eval(i +'/16'));
            }

            function itohex(i) {
                if( i == 0) { aa = '0' }
                else { if( i == 1 ) { aa = '1' }
                else { if( i == 2 ) { aa = '2' }
                else { if( i == 3 ) { aa = '3' }
                else { if( i == 4 ) { aa = '4' }
                else { if( i == 5 ) { aa = '5' }
                else { if( i == 6 ) { aa = '6' }
                else { if( i == 7 ) { aa = '7' }
                else { if( i == 8 ) { aa = '8' }
                else { if( i == 9 ) { aa = '9' }
                else { if( i == 10) { aa = 'a' }
                else { if( i == 11) { aa = 'b' }
                else { if( i == 12) { aa = 'c' }
                else { if( i == 13) { aa = 'd' }
                else { if( i == 14) { aa = 'e' }
                else { if( i == 15) { aa = 'f' }
                }}}}}}}}}}}}}}}
                return aa;
            }

            function ConvShowcolor(color) {
                if ( c=color.match(/rgb\\((\\d+?)\\, (\\d+?)\\, (\\d+?)\\)/i) ) {
                    var rhex = tohex(c[1]);
                    var ghex = tohex(c[2]);
                    var bhex = tohex(c[3]);
                    var newcolor = '#'+rhex+ghex+bhex;
                }
                else {
                    var newcolor = color;
                }
                if(thistask == "post") showcolor(newcolor);
                if(thistask == "templ") previewColor(newcolor);
            }
            //-->
            </script>
                <img src="$imagesdir/palette1.gif" style="cursor: pointer; margin:0 -2px" width='23' height='22' onclick="window.open('$scripturl?action=palette;task=post', '', 'height=308,width=302,menubar=no,toolbar=no,scrollbars=no')" alt="" />
~;
    }
    return;
}

sub Template {

    if ( $iamguest && $enable_gr == 0 ) {
        print qq~Content-type:text/html\n\n~ or croak "$croak{'print'} TOP";
        print
qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <title>$name_sb</title>
    <meta http-equiv="Content-Type" content="text/html; charset=$yymycharset" />
    <meta http-equiv="pragma" CONTENT="no-cache" />
    <link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />
</head>
<body>
    <table style="width:35%">
        <tr>
        <td class="small">
            $shout_txt{'15a'}<br /><br />
            $shout_txt{'16'} <a href="$scripturl?action=register" target="_blank">$scripturl</a>
        </td>
    </tr>
</table>
</body>
</html>~ or croak "$croak{'print'} BODY";

        exit;

    }
    else {

        ShowExtras();
        print qq~Content-type:text/html\n\n~ or croak "$croak{'print'} TOP";
        print
qq~<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <style type="text/css">
        html, body {
        scrollbar-base-color:$sb_basecolor;
        scrollbar-3d-light-color:$sb_3dlightcolor;
        scrollbar-arrow-color:$sb_arrowcolor;
        scrollbar-darkshadow-color:$sb_darkshadowcolor;
        scrollbar-face-color:$sb_facecolor;
        scrollbar-highlight-color:$sb_highlightcolor;
        scrollbar-shadow-color:$sb_shadowcolor;
        scrollbar-track-color:$sb_trackcolor;
    }
    </style>
    <title>$name_sb</title>
    <meta http-equiv="Content-Type" content="text/html; charset=$yymycharset" />
    <meta http-equiv="pragma" content="no-cache" />
    <link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />
    <script src="$yyhtml_root/shoutnew.js" type="text/javascript"></script>
    <script type="text/javascript">
    /* Opens windows for smilies and previous shouts */
        function openWindow(theURL,winName,features) {
            window.open(theURL,winName,features);
    }
    /* clears default values from input boxes */
        function clearText(thefield) {
            if (thefield.defaultValue==thefield.value)
                thefield.value = ""
        }
    /* Uses hidden form fields so message never disappears accidentally */
        function changevalue() {
            if (document.shoutbox.message.defaultValue == document.shoutbox.message.value)
            {
                alert("$shout_txt{'45'}");
                return false;
            }
            else
            {
                document.shoutbox.shoutout.value = document.shoutbox.message.value;
                document.shoutbox.message.value = "";
            }
        }
$refresh_js
    </script>
    <script type="text/javascript">
//** Form field Limiter v2.0- (c) Dynamic Drive DHTML code library: http://www.dynamicdrive.com
//** Feb 25th, 09'- Script creation date
//** This notice must stay intact for legal use

var fieldlimiter={

defaultoutput: "$shout_txt{'65a'} <b>[int]</b> $shout_txt{'66'}",
uncheckedkeycodes: /(8)|(13)|(16)|(17)|(18)/,

limitinput:function(e, config){
    var e=window.event || e
    var thefield=config.thefield
    var keyunicode=e.charCode || e.keyCode
    if (!this.uncheckedkeycodes.test(keyunicode)){
        if (thefield.value.length>=config.maxlength){
            if (e.preventDefault)
                e.preventDefault()
            return false
        }
    }
},

showlimit:function(config){
    var thefield=config.thefield
    var statusids=config.statusids
    var charsleft=config.maxlength-thefield.value.length
    if (charsleft<0)
        thefield.value=thefield.value.substring(0, config.maxlength) //trim input
    for (var i=0; i<statusids.length; i++){
        var statusdiv=document.getElementById(statusids[i])
        if (statusdiv) //if status DIV defined
            statusdiv.innerHTML=this.defaultoutput.replace("[int]", Math.max(0, charsleft))
    }
    config.onkeypress.call(thefield, config.maxlength, thefield.value.length)
},

cleanup:function(config){
    for (var prop in config){
        config[prop]=null
    }
},

addEvent:function(targetarr, functionref, tasktype){
    if (targetarr.length>0){
        var target=targetarr.shift()
        if (target.addEventListener)
            target.addEventListener(tasktype, functionref, false)
        else if (target.attachEvent)
            target.attachEvent('on'+tasktype, function(){return functionref.call(target, window.event)})
        this.addEvent(targetarr, functionref, tasktype)
    }
},

setup:function(config){
    if (config.thefield){ //if form field exists
        config.onkeypress=config.onkeypress || function(){}
        config.thefield.value=config.thefield.value
        this.showlimit(config)
        this.addEvent([window], function(e){fieldlimiter.showlimit(config)}, "load")
        this.addEvent([window], function(e){fieldlimiter.cleanup(config)}, "unload")
        this.addEvent([config.thefield], function(e){return fieldlimiter.limitinput(e, config)}, "keypress")
        this.addEvent([config.thefield], function(){fieldlimiter.showlimit(config)}, "keyup")
    }
}

}
    </script>
    <script type="text/javascript">
//Scrollable content III- By http://www.dynamicdrive.com

var speed, currentpos=curpos1=0,alt=1,curpos2=-1

function initialize(){
if (window.parent.scrollspeed!=0){
speed=window.parent.scrollspeed
scrollwindow()
}
}

function scrollwindow(){
temp=(document.all)? document.body.scrollTop : window.pageYOffset
alt=(alt==0)? 1 : 0
if (alt==0)
curpos1=temp
else
curpos2=temp

window.scrollBy(0,speed)
}

setInterval("initialize()",10)

    </script>
</head>
<body onload="timer(); $shoutbox_on_load_focus"; style="min-width:0px;">
    <div style="position:relative;bottom:$shout_text_height3$px;padding-top:$shout_text_height4$px;">
        <table>
            <tr>
                <td>
                $shout_rows
                </td>
                <td>
                    <div class="shout_postarea center" style="position:fixed;bottom:0px;padding-top:6px;height:$shout_text_height2$px;">
                    $bbcode_bar
                    <form name="shoutbox" action="$shoutform_action" method="post" onSubmit="changevalue()">
                        <input type="hidden" name="shoutout" maxlength="$max_shout_length" />
                        <input type="hidden" name="formsession" value="$formsession" /><br />
                        <input type="text" name="message" size="33" maxlength="$max_shout_length" onfocus="clearText(this)" value="" /><br />
                        $limiter
                        <input type="submit" name="Submit" value="$shout_txt{'31'}" /> <input type="reset" value="$shout_txt{'31a'}" />
                    </form>
                    <br />
                    $smiley_bar
                    <br />
                    <div class="small">
                        <a href="javascript:openWindow('./ShoutDisplay.pl?showall=1','shoutbox','toolbar=no,scrollbars=yes,locationbar=0,directories=no,status=no,resizable=$as_window_resize,menubar=no,width=$as_window_width,height=$as_window_height')">$shout_txt{'32'}</a>
                        &nbsp;|&nbsp;
                        <a href="javascript:openWindow('$scripturl?action=shout_smilies','smilies','toolbar=no,locationbar=0,directories=no,status=no,resizable=no,menubar=no,width=$mo_window_width,height=$mo_window_height')">$shout_txt{'33'}</a>
                        &nbsp;|&nbsp;
                        <a href="javascript:window.location.reload();">$shout_txt{'34'}</a>
                    </div>
                </div>
    <script type="text/javascript">
    fieldlimiter.setup({
    thefield: document.shoutbox.message,
    maxlength: $max_shout_length,
    statusids: ["shoutlimiter"],
    onkeypress:function(maxlength, curlength){
        if (curlength<maxlength)
            this.style.border="0px solid gray"
        else
            this.style.border="2px solid red"
    }
})
    </script>
            </td>
        </tr>
    </table>
    </div>
~ or croak "$croak{'print'} Body";

        Timer();

        print q~
</body>
</html>~ or croak "$croak{'print'} TOP";
    }
    return;
}

sub smiley_list {
    my %list    = @_;
    my $hand    = q~class="vtop cursor" style="margin:1px;"~;
    my $boxlist = q{};
    my $w       = 0;
    for my $i ( sort keys %list ) {
        my ( $img, $click, $alt ) = split /[|]/xsm, $list{$i};
        my $autobr = q{};
        if ( $w == 8 && $shout_width < 380 ) {
            $autobr = q~<br />~;
        }
        $boxlist .=
qq~$autobr<img src='$imagesdir/$img' onclick='$click' $hand alt='$alt' title='$alt' />\n~;
        $w++;
    }
    $boxlist_w = $w * 23;
    return ( $boxlist, $boxlist_w );
}

sub ubbc_boxlist {
    my %list    = @_;
    my $hand    = q~class="vtop cursor" style="margin:0 -2px;"~;
    my $boxlist = q{};
    my $w       = 0;
    for my $i ( sort keys %list ) {
        my ( $img, $click, $alt ) = split /[|]/xsm, $list{$i};
        $boxlist .=
qq~<img src='$imagesdir/$img' onclick='$click' $hand alt='$alt' title='$alt' />\n~;
        $w++;
    }
    $boxlist_w = $w * 23;
    return ( $boxlist, $boxlist_w );
}
1;
