#################################################################################################
# Shoutbox.pl: 		Part of the Shoutbox 2.4 Mod						#
# Copyright:      	2005 Andrew Aitken (LoonyPandora)					#
# Version:         	Shoutbox 2.4 RC5.5							#
# Released:        	13th May, 2009								#
# Distributed by:  	http://www.boardmod.org							#
# Update by: 		Batchman, Derek Barnstorm, D0T-C0M, Driven, Unilat, ThM with permission	#
#################################################################################################

$shoutboxplver = 'Shoutbox Mod for YaBB 2.4 RC5.5';

if ($action eq 'detailedversion') { return 1; }


LoadLanguage("Post");

LoadLanguage("Shoutbox");


if (!-e "$vardir/shoutsettings.txt") {
 &fatal_error("$shout_txt{'7'}");
 }
else {
 require "$vardir/shoutsettings.txt";
 }

sub WriteShouts {


	#&spam_protection;

	&CheckCanShout;


	my $shout_message  = $FORM{'shoutout'};

	my $shout_username = $username;

	my $shout_name     = ${$uid.$username}{'realname'};

	our $shout_time = &GetShoutTime;


	if ($shout_message) {

		$shout_message = &WriteSpecialChars($shout_message);


		$new_shout = qq~$shout_time|$shout_name|$shout_username|$shout_message\n~;


		fopen(SHOUTS, "+<$vardir/shouts.txt");

		@shouts = <SHOUTS>;


		push(@shouts, $new_shout);

		if ($#shouts > $maximum_shouts) { shift(@shouts); }


		seek SHOUTS, 0, 0;

		truncate SHOUTS, 0;

		print SHOUTS @shouts;


		fclose(SHOUTS);

	}


	if (!$iamguest) { &UpdateShoutCount; }


	if ($INFO{'showall'}) { $yySetLocation = qq~$boardurl/ShoutDisplay.pl?showall=1~; }

	else { $yySetLocation = qq~$boardurl/ShoutDisplay.pl~; }


	&redirectexit;

}



sub UpdateShoutCount {


	# Increment shout count

	${$uid.$username}{'lp_shoutcount'}++;

	${$uid.$username}{'lp_lastshout'} = $shout_time;

	&UserAccount($username, "update");

}



sub GetShoutTime {

	my $shout_time = int(time);

	return $shout_time;

}



sub WriteSpecialChars {

	$message = $_[0];

	&ToHTML($message);


	# Remove img tags

	$message =~ s~\[img(.*)?\](.*)\[/img\]~$2~i;

	$message =~ s~\[size=(.+?)\](.+?)\[/size\]~&my_sizefont($1,$2)~eisg;


	return $message;

}



sub my_sizefont {


	# limit minimum and maximum font pitch as CSS does not restrict it at all

	my ($tsize, $ttext) = @_;

	$fontsizemax = 20;

	$fontsizemin = 6;

	if    ($tsize < $fontsizemin) { $tsize = $fontsizemin; }

	elsif ($tsize > $fontsizemax) { $tsize = $fontsizemax; }

	my $resized = qq~\[size=$tsize]$ttext\[/size]~;

	return $resized;

}



sub UserRemoveShouts {

	$shout_name = $INFO{'user'};
	if ($username eq $shout_name || $iamadmin) { 
            $shout_to_delete = $INFO{'shout'};


		fopen(SHOUTS, "+<$vardir/shouts.txt") || &fatal_error("$shout_txt{'8'} $vardir/shouts.txt - $!", 1);

		my $buffer = 1;

		my $found  = 0;

		while ($buffer) {

			$offset = tell SHOUTS;

			$buffer = <SHOUTS>;

			if ($buffer =~ m~\A$shout_to_delete~) {

				$slice = ($. - 1);

				$found = 1;

				last;

			}

		}


		if ($found) {

			seek SHOUTS, 0, 0;

			my @contents = <SHOUTS>;

			$contents[$slice] = q~~;

			seek SHOUTS, 0, 0;

			truncate SHOUTS, 0;

			print SHOUTS @contents;

		}


		fclose(SHOUTS);


		if ($INFO{'showall'}) { $yySetLocation = qq~$boardurl/ShoutDisplay.pl?showall=1~; }

		else { $yySetLocation = qq~$boardurl/ShoutDisplay.pl~; }


		&redirectexit;


	} else {
	&fatal_error('shout_delete'); 
	}

} 


sub ShoutSmileys {

	if ($smiliestyle eq 1) { $smiliewinlink = "$scripturl?action=smilieput"; }

	else { $smiliewinlink = "$scripturl?action=smilieindex"; }


	print qq~Content-type:text/html\n\n~;

	print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$name_sb</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
</head>
<body>
<div style="float: left; width: 360px;">
<br />
<form name="addsmileys">
~;


	&ShoutBBCode;

	&NormalSmileys;

	&AddMoreSmileys;

}



sub ShoutBBCode {
	print qq~<script language="JavaScript1.2" src="$yyhtml_root/shout.js" type="text/javascript"></script>~;
	if ($enable_ubbc && $showyabbcbutt) {
		print qq~
<table align="center">
  <tr>
     <td valign="middle">
        <script language="JavaScript1.2" type="text/javascript">
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          HAND = "onmouseover=this.style.cursor='hand'";
			document.write("<img src='$imagesdir/bold.gif' onclick='bold();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'253'}' title='$post_txt{'253'}' border='0' />");
			document.write("<img src='$imagesdir/italicize.gif' onclick='italicize();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'254'}' title='$post_txt{'254'}' border='0' />");
			document.write("<img src='$imagesdir/underline.gif' onclick='underline();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'255'}' title='$post_txt{'255'}' border='0' />");
			document.write("<img src='$imagesdir/strike.gif' onclick='strike();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'441'}' title='$post_txt{'441'}' border='0' />");	
			document.write("<img src='$imagesdir/move.gif' onclick='move();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'439'}' title='$post_txt{'439'}' border='0' />");
			document.write("<img src='$imagesdir/tele.gif' onclick='teletype();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'440'}' title='$post_txt{'440'}' border='0' />");
			document.write("<img src='$imagesdir/url.gif' onclick='hyperlink();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'257'}' title='$post_txt{'257'}' border='0' />");
			document.write("<img src='$imagesdir/email2.gif' onclick='emai1();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'258'}' title='$post_txt{'258'}' border='0' />");
          		document.write("<img src='$imagesdir/sup.gif' onclick='superscript();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'447'}' border='0' />");
          		document.write("<img src='$imagesdir/sub.gif' onclick='subscript();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'448'}' border='0' />");
        }
        else { document.write("<span class='small'>$post_txt{'215'}</span>"); }
			// Palette
			var thistask = 'post';
			function tohex(i) {
				a2 = ''
				ihex = hexQuot(i);
				idiff = eval(i + '-(' + ihex + '*16)')
				a2 = itohex(idiff) + a2;
				while( ihex >= 16) {
					itmp = hexQuot(ihex);
					idiff = eval(ihex + '-(' + itmp + '*16)');
					a2 = itohex(idiff) + a2;
					ihex = itmp;
				} 
				a1 = itohex(ihex);
				return a1 + a2 ;
			}

			function hexQuot(i) {
				return Math.floor(eval(i +'/16'));
			}

			function itohex(i) {
				if( i == 0) { aa = '0' }
				else { if( i == 1 ) { aa = '1' }
				else { if( i == 2 ) { aa = '2' }
				else { if( i == 3 ) { aa = '3' }
				else { if( i == 4 ) { aa = '4' }
				else { if( i == 5 ) { aa = '5' }
				else { if( i == 6 ) { aa = '6' }
				else { if( i == 7 ) { aa = '7' }
				else { if( i == 8 ) { aa = '8' }
				else { if( i == 9 ) { aa = '9' }
				else { if( i == 10) { aa = 'a' }
				else { if( i == 11) { aa = 'b' }
				else { if( i == 12) { aa = 'c' }
				else { if( i == 13) { aa = 'd' }
				else { if( i == 14) { aa = 'e' }
				else { if( i == 15) { aa = 'f' }
				}}}}}}}}}}}}}}}
				return aa;
			}

			function ConvShowcolor(color) {
				if ( c=color.match(/rgb\\((\\d+?)\\, (\\d+?)\\, (\\d+?)\\)/i) ) {
					var rhex = tohex(c[1]);
					var ghex = tohex(c[2]);
					var bhex = tohex(c[3]);
					var newcolor = '#'+rhex+ghex+bhex;
				}
				else {
					var newcolor = color;
				}
				if(thistask == "post") showcolor(newcolor);
				if(thistask == "templ") previewColor(newcolor);
			}
			//-->
			</script>
				<img src="$imagesdir/palette1.gif" style="cursor: pointer" width='23' height='22' onclick="window.open('$scripturl?action=palette;task=post', '', 'height=308,width=302,menubar=no,toolbar=no,scrollbars=no')" alt="" border="0" />
			<noscript>
			<span class="small">$maintxt{'noscript'}</span>
			</noscript>
        </script>
        </td>
      </tr>
	</table>
~;
	}

	# Change Colour section
	print qq~
<table align="center">
	<tr>
	  <td align="center">
		$shout_txt{'35'}
	  </td>
	</tr>
	<tr>
	  <td align="center">
<script language="JavaScript1.2" type="text/javascript">
			document.write('<select name="fontface" id="fontface" onchange="if(this.options[this.selectedIndex].value) fontfce(this.options[this.selectedIndex].value);" style="width: 105px; margin-top: 2px; margin-left: 2px; margin-right: 1px; font-size: 9px;">');
			document.write('<option value="">Verdana</option>');
			document.write('<option value="">-\\-\\-\\-\\-\\-\\-\\-\\-</option>');
			document.write('<option value="Arial" style="font-family: Arial">Arial</option>');
			document.write('<option value="Bitstream Vera Sans Mono" style="font-family: Bitstream Vera Sans Mono">Bitstream</option>');
			document.write('<option value="Bradley Hand ITC" style="font-family: Bradley Hand ITC">Bradley Hand ITC</option>');
			document.write('<option value="Comic Sans MS" style="font-family: Comic Sans MS">Comic Sans MS</option>');
			document.write('<option value="Courier" style="font-family: Courier">Courier</option>');
			document.write('<option value="Courier New" style="font-family: Courier New">Courier New</option>');
			document.write('<option value="Georgia" style="font-family: Georgia">Georgia</option>');
			document.write('<option value="Impact" style="font-family: Impact">Impact</option>');
			document.write('<option value="Lucida Sans" style="font-family: Lucida Sans">Lucida Sans</option>');
			document.write('<option value="Microsoft Sans Serif" style="font-family: Microsoft Sans Serif">MS Sans Serif</option>');
			document.write('<option value="Papyrus" style="font-family: Papyrus">Papyrus</option>');
			document.write('<option value="Tahoma" style="font-family: Tahoma">Tahoma</option>');
			document.write('<option value="Tempus Sans ITC" style="font-family: Tempus Sans ITC">Tempus Sans ITC</option>');
			document.write('<option value="Times New Roman" style="font-family: Times New Roman">Times New Roman</option>');
			document.write('<option value="Verdana" style="font-family: Verdana">Verdana</option>');
			document.write('</select>');
			var fntoptions = ["6", "7", "8", "9", "10", "11", "12", "14", "16", "18", "20"]
			document.write('<select name="fontsize" id="fontsize" onchange="if(this.options[this.selectedIndex].value) fntsize(this.options[this.selectedIndex].value);" style="width: 39px; margin-top: 2px; margin-left: 1px; margin-right: 2px; font-size: 9px;">');
			document.write('<option value="">11</option>');
			document.write('<option value="">-\\-</option>');
			for(var i = 0; i < fntoptions.length; i++) {
				if(fntoptions[i] >= $fontsizemin && fntoptions[i] <= $fontsizemax) {
					if(fntoptions[i] == 11) document.write('<option value="11" selected="selected">11</option>');
					else document.write('<option value=' + fntoptions[i] + '>' + fntoptions[i] + '</option>');
				}
			}
			document.write('</select>')
</script>
	  </td>
	</tr>
</table><br />
~;
}

sub NormalSmileys {
	print qq~
<table align="center">
      <tr>
        <td valign="middle">
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          HAND = "onmouseover=this.style.cursor='hand'";
          document.write("<img src='$imagesdir/smiley.gif' onclick='smiley();' "+HAND+" align=bottom alt='$post_txt{'287'}' border='0'> ");
          document.write("<img src='$imagesdir/wink.gif' onclick='wink();' "+HAND+" align=bottom alt='$post_txt{'292'}' border='0'> ");
          document.write("<img src='$imagesdir/cheesy.gif' onclick='cheesy();' "+HAND+" align=bottom alt='$post_txt{'289'}' border='0'> ");
          document.write("<img src='$imagesdir/grin.gif' onclick='grin();' "+HAND+" align=bottom alt='$post_txt{'293'}' border='0'> ");
          document.write("<img src='$imagesdir/angry.gif' onclick='angry();' "+HAND+" align=bottom alt='$post_txt{'288'}' border='0'> ");
          document.write("<img src='$imagesdir/sad.gif' onclick='sad();' "+HAND+" align=bottom alt='$post_txt{'291'}' border='0'> ");
          document.write("<img src='$imagesdir/shocked.gif' onclick='shocked();' "+HAND+" align=bottom alt='$post_txt{'294'}' border='0'> ");
          document.write("<img src='$imagesdir/cool.gif' onclick='cool();' "+HAND+" align=bottom alt='$post_txt{'295'}' border='0'> ");
          document.write("<img src='$imagesdir/huh.gif' onclick='huh();' "+HAND+" align=bottom alt='$post_txt{'296'}' border='0'> ");
          document.write("<img src='$imagesdir/rolleyes.gif' onclick='rolleyes();' "+HAND+" align=bottom alt='$post_txt{'450'}' border='0'> ");
          document.write("<img src='$imagesdir/tongue.gif' onclick='tongue();' "+HAND+" align=bottom alt='$post_txt{'451'}' border='0'> ");
          document.write("<img src='$imagesdir/embarassed.gif' onclick='embarassed();' "+HAND+" align=bottom alt='$post_txt{'526'}' border='0'> ");
          document.write("<img src='$imagesdir/lipsrsealed.gif' onclick='lipsrsealed();' "+HAND+" align=bottom alt='$post_txt{'527'}' border='0'> ");
          document.write("<img src='$imagesdir/undecided.gif' onclick='undecided();' "+HAND+" align=bottom alt='$post_txt{'528'}' border='0'> ");
          document.write("<img src='$imagesdir/kiss.gif' onclick='kiss();' "+HAND+" align=bottom alt='$post_txt{'529'}' border='0'> ");
          document.write("<img src='$imagesdir/cry.gif' onclick='cry();' "+HAND+" align=bottom alt='$post_txt{'530'}' border='0'> ");$moresmilieslist
        }
        else { document.write("<span  class='small'>$post_txt{'215'}</span>"); }
        //-->
        </script>
		</td></tr>
	</table>
~;
}

sub AddMoreSmileys {
	print qq~
	<script language="JavaScript1.2" type="text/javascript">
	<!--
		function Smiliextra() {
		AddTxt=smiliecode[document.addsmileys.smiliextra_list.value];
		AddText(AddTxt);
		}

		function smiliewin() {
		window.open("$smiliewinlink", 'list', 'width=$winwidth,height=$winheight, scrollbars=yes');
		}

		function showimage() {
		document.images.icons.src="$imagesdir/"+document.addsmileys.icon.options[document.addsmileys.icon.selectedIndex].value+".gif";
		}
    //-->
	</script>
	<noscript>Cannot use smileys, as you do not have JavaScript enabled</noscript>
	<br />
~;

	opendir(DIR, "$smiliesdir");
	@contents = readdir(DIR);
	closedir(DIR);
	$i = 0;
	foreach $line (sort { uc($a) cmp uc($b) } @contents) {
		($name, $extension) = split(/\./, $line);
		if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i) {
			if ($line !~ /banner/i) {
				$smilieslist       .= qq~           document.write("<option value='$i'>$name");\n~;
				$smilie_url_array  .= qq~"$smiliesurl/$line", ~;
				$smilie_code_array .= qq~" [smiley=$line]", ~;
				$i++;
			}
		}
	}
	$smilie_url_array  .= qq~""~;
	$smilie_code_array .= qq~""~;

	print qq~
	<script language="JavaScript1.2" type="text/javascript">
	<!--
	smilieurl = new Array($smilie_url_array)
	smiliecode = new Array($smilie_code_array)

        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
	  document.write('<table class="bordercolor" height="90" width="120" border="0" cellpadding="2" cellspacing="1" align="center"><tr>');
	  document.write('<td height="15" align="center" valign="middle" class="titlebg"><span class="small"><b>$post_smiltxt{'1'}</b></span></td>');
	  document.write('</tr><tr>');
          document.write('<td height="20" align="center" valign="top" class="windowbg2"><select name="smiliextra_list" onchange="document.images.smiliextra_image.src= smilieurl[document.addsmileys .smiliextra_list.value]" style="width:114px; font-size:7pt">');
	  $smilieslist
          document.write('</select></td>');
          document.write('</tr><tr>');
          document.write('<td align="center" valign="middle" class="windowbg2"><img name="smiliextra_image" src="'+smilieurl[0]+'" alt="" border="0" onclick="javascript:Smiliextra()" style="cursor:hand"></td>');
          document.write('</tr></table>');
	}
        //-->
        </script>
		</form>
		<br /><br />~;

	print qq~
	</div>
		</body>
		</html>
        ~;

}

sub CheckCanShout {
	($shout_mute_days, $shout_mute_until) = split(/\|/, ${$uid.$username}{'lp_shout_muted'});

	if ($iamguest) {
		print qq~Content-type:text/html\n\n~;
		print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$name_sb</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
<meta http-equiv="pragma" CONTENT="no-cache" />
<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
</head>

<table width="35%">
<tr>
<td>
<span class="small">$shout_txt{'15'}<br /><br />
$shout_txt{'16'} <a href="$scripturl?action=register" target="_blank">$scripturl</a>
</span>

<br /><br />
<a href="$boardurl/ShoutDisplay.pl">$shout_txt{'11'}</a>
</td>
</tr>
</table>
</body>
</html>~;

		exit;

	} elsif ($shout_mute_until > int(time)) {

		print qq~Content-type:text/html\n\n~;
		print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$name_sb</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
<meta http-equiv="pragma" CONTENT="no-cache" />
<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
</head>
<table width="40%>
<td class="small">
<tr>
<span class="small">$shout_txt{'9'}<br /><br />
${$uid.$username}{'lp_shout_mute_reason'}<br /><br />
$shout_txt{'10'} $shout_mute_days $shout_txt{'17'}</span>

<br /><br />
<a href="$boardurl/ShoutDisplay.pl">$shout_txt{'11'}</a>
</tr>
</td>
</table>
</body>
</html>~;

		exit;

	} elsif (${$uid.$username}{'postcount'} < $min_posts) {

		print qq~Content-type:text/html\n\n~;
		print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$name_sb</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yycharset" />
<meta http-equiv="pragma" CONTENT="no-cache" />
<link rel="stylesheet" href="$forumstylesurl/$usestyle.css" type="text/css" />
</head>

<span class="small">$shout_txt{'12'} $min_posts times $shout_txt{'13'}<br /><br />
$shout_txt{'14'}<br /><a href="$scripturl">$scripturl</a></span>

<br /><br />
<a href="$boardurl/ShoutDisplay.pl">$shout_txt{'11'}</a>
</body>
</html>~;


		exit;

	}

}


1;
