<id>
Shoutbox Mod for YaBB 2.6.0
</id>

<version>
0.1
</version>

<mod info>
It allows a "shoutbox" to be placed anywhere on your website. This allows members to chat quickly, rather than making posts. This is NOT designed to be a chat-system, but is somewhere in-between posting, and realtime chat.
Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified and ShoutBox files their respective locations on your server in ASCII mode. ( ShoutDisplay.pl should be chmod 755, or the same as YaBB.pl)
3) Upload the Shoutbox folder and graphics to the ModImages directory in Binary mode.
4) Go to 'Admin Center - ShoutBox' to set your options.

Files to edit
-------------
AdminIndex.pl
Admin/AdminSublist.pm
Admin/ModList.pm
Languages/English/Error.lng
Sources/Palette.pm
Sources/Profile.pm
Sources/Register.pm
Sources/SubList.pm
Sources/System.pm
Templates/default/BoardIndex.template
Templates/default/MyProfiles.template

Upload all files to the relevant directories, and chmod according to the other files in the same directory. ShoutDisplay.pl should be chmod 755, or the same as YaBB.pl
</mod info>

<author>
Andrew Aitken (LoonyPandora) and others
</author>

<homepage>
http://www.yabbforumsoftware.com.net/cgi-bin/yabb2/YaBB.pl
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $lp_shout = "shoutadmin|Shoutbox Settings|Shoutbox Mod by Andrew Aitken (LoonyPandora) and many others|";
    push @boardmod_mods, $lp_shout;
</add before>

<edit file>
Admin/AdminSubList.pm
</edit file>

<search for>
);

1;
</search for>

<add before>
'shoutadmin',"ShoutAdmin.pm&ShoutAdmin",
'removeshouts',"ShoutAdmin.pm&RemoveShouts",
'shoutsettings2',"ShoutAdmin.pm&ShoutSettings2",
</add before>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $lp_shout = q~Shoutbox|Andrew Aitken (LoonyPandora) and many others|Updated for YaBB 2.4 in community work from Batchman, DOT-COM, Derek Barnstorm, Driven, Unilat and ThM. Gives users an interactive shoutbox, almost like a chat-room, or instant messaging client direct on your forum. Can be utilised via an iframe from any page on your website. Ideal for "portals".|RC5.5|13th May 2009~;
    push @installed_mods, $lp_shout;
</add before>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
## MemberGroups ##
'newpostdep_gmod'       => 'Sorry, Global Mods cannot modify Post-dependent users because the Maintenance->"Rebuild Memberlist" must be run after and that function is only available in Maintenance Mode, so it would deny your login.',
</search for>

<add after>
## Shoutbox ##
'shout_delete' => 'You do not have permissions to delete this shout.',
</add after>

<edit file>
Sources/Palette.pm
</edit file>

<search for>
        if(picktask == "templ_1") opener.previewColor_1(newcolor);
</search for>

<add after>
        if(picktask == "templ_5") opener.previewColor_5(newcolor);
        if(picktask == "templ_6") opener.previewColor_6(newcolor);
        if(picktask == "templ_7") opener.previewColor_7(newcolor);
        if(picktask == "templ_8") opener.previewColor_8(newcolor);
        if(picktask == "templ_9") opener.previewColor_9(newcolor);
        if(picktask == "templ_10") opener.previewColor_10(newcolor);
</add after>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
LoadLanguage('Profile');
</search for>

<add after>
LoadLanguage('Shoutbox');
</add after>

<search for>
    if ( ${ $uid . $user }{'position'} eq 'Administrator' ) {
        $tt = $MemStatAdmin;
    }
</search for>

<add before>
    ($shout_mute_days, undef) = split /\|/xsm, ${$uid.$user}{'lp_shout_muted'};

</add before>

<search for>
    ${ $uid . $user }{'regdate'}   = $member{'dr'};
</search for>

<add after>
    $mute_until = ( $member{'lp_shout_muted'} * 86_400 )+ int(time);
    ${ $uid . $user }{'lp_shout_muted'} = "$member{'lp_shout_muted'}|$mute_until";
    ${ $uid . $user }{'lp_shout_mute_reason'}   = "$member{'lp_shout_mute_reason'}";
</add after>

<search for>
    $post_count = ${ $uid . $user }{'postcount'};
    if ( !$post_count ) { $post_count = 0 }
</search for>

<add after>

    $shout_count = ${ $uid . $user }{'lp_shoutcount'};
    if ( !$shout_count ) { $shout_count = 0 }
</add after>

<search for>
    $post_per_day    = sprintf '%.2f', ( $post_count / $tmpmember_for_days );
</search for>

<add after>
    $shout_per_day   = sprintf '%.2f', ( ${ $uid . $user }{'lp_shoutcount'} / $tmpmember_for_days );
</add after>

<search for>
    if ( $user_hide_avatars && $showuserpic && $allowpics )
</search for>

<add before>
    if (${ $uid . $user }{'lp_shout_timestamp'}) { $lp_time_checked = q~ checked="checked"~; }
    if (${ $uid . $user }{'lp_shout_smileys'}) { $lp_smiley_checked = q~ checked="checked"~; }
    if (${ $uid . $user }{'lp_shout_bbcode'}) { $lp_bbcode_checked = q~ checked="checked"~; }
    if (${ $uid . $user }{'on_load_focus'}) { $on_load_focus_checked = q~ checked="checked"~; }
    if (${ $uid . $user }{'reverse_post'}) { $reverse_post_checked = q~ checked="checked"~; }
</add before>

<search for>
    ${ $uid . $user }{'return_to'}    = $member{'return_to'};
</search for>

<add after>
    ${ $uid . $user }{'lp_shout_refresh'}   = $member{'lp_shout_refresh'};
    ${ $uid . $user }{'lp_shout_timestamp'} = $member{'lp_shout_timestamp'};
    ${ $uid . $user }{'lp_shout_smileys'}   = $member{'lp_shout_smileys'};
    ${ $uid . $user }{'lp_shout_bbcode'}    = $member{'lp_shout_bbcode'};
    ${ $uid . $user }{'on_load_focus'}      = $member{'on_load_focus'};
    ${ $uid . $user }{'reverse_post'}       = $member{'reverse_post'};
</add after>

<search for>
            <div class="contactright">$userlastim</div>~;
</search for>

<replace>
            <div class="contactright">$userlastim</div>
            <div class="contactleft"><b>$shout_txt{'5'}</b></div>
            <div class="contactright">~;

            if (!${ $uid . $user }{'lp_lastshout'}) { $userlastshout = "$maintxt{'470'}" }
            else { $userlastshout = timeformat(${ $uid . $user }{'lp_lastshout'}); }
            $my_lastPM .= qq~$userlastshout
            </div>~;
</replace>

<search for>
    if (${ $uid . $user }{'reverse_post'}) { $reverse_post_checked = q~ checked="checked"~; }
</search for>

<add after>

    my $my_show_shout = $mod_shoutbox;
    $my_show_shout =~ s/{yabb lp_time_checked}/$lp_time_checked/sm;
    $my_show_shout =~ s/{yabb lp_smiley_checked}/$lp_smiley_checked/sm;
    $my_show_shout =~ s/{yabb lp_bbcode_checked}/$lp_bbcode_checked/sm;
    $my_show_shout =~ s/{yabb on_load_focus_checked}/$on_load_focus_checked/sm;
    $my_show_shout =~ s/{yabb reverse_post_checked}/$reverse_post_checked/sm;
    $my_show_shout =~ s/{yabb lp_shout_refresh}/${ $uid . $user }{'lp_shout_refresh'}/sm;
</add after>

<search for>
    $showProfile =~ s/{yabb my_show_lang}/$my_show_lang/sm;
</search for>

<add after>
    $showProfile =~ s/{yabb my_show_shout}/$my_show_shout/sm;
</add after>

<search for>
    $showProfile =~ s/{yabb my_extprofile}/$my_extprofile/sm;
</search for>

<add after>
    $showProfile =~ s/{yabb shout_mute_days}/$shout_mute_days/sm;
    $showProfile =~ s/{yabb user_lp_shout_mute_reason}/${$uid.$user}{'lp_shout_mute_reason'}/sm;
</add after>

<search for>
    $showProfile .= $myshow_profile;
</search for>

<add before>
    if ( !${$uid.$user}{'lp_shoutcount'} ) {
		${$uid.$user}{'lp_shoutcount'} = 0;
	}
</add before>

<search for>
    $showProfile =~ s/{yabb post_per_day}/$post_per_day/sm;
</search for>

<add after>
    $showProfile =~ s/{yabb lp_shoutcount}/${$uid.$user}{'lp_shoutcount'}/sm;
    $showProfile =~ s/{yabb shout_per_day}/$shout_per_day/sm;
</add after>

<edit file>
Sources/Register.pm
</edit file>

<search for>
        ${ $uid . $reguser }{'addgroups'} = join q{,}, @newmemgr;
    }
</search for>

<add after>
        # Shoutbox defaults
        ${ $uid . $reguser }{'lp_shout_smileys'} = 1;
        ${ $uid . $reguser }{'lp_shout_timestamp'} = 1;
        ${ $uid . $reguser }{'lp_shout_bbcode'} = 1;
        ${ $uid . $reguser }{'on_load_focus'} = 1;
        ${ $uid . $reguser }{'reverse_post'} = 1;
        ${ $uid . $reguser }{'lp_shout_refresh'} = 45;
</add after>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
'vote','Poll.pm&DoVote',
</search for>

<add after>
'write_shouts',"Shoutbox.pm&WriteShouts",
'shout_smilies',"Shoutbox.pm&ShoutSmileys",
'useremoveshouts',"Shoutbox.pm&UserRemoveShouts",
</add after>

<edit file>
Sources/System.pm
</edit file>

<search for>
   ## Mod hook ##
</search for>

<add before>
    push @tags, 'lp_shoutcount','lp_lastshout','lp_shout_muted','lp_shout_mute_reason','lp_shout_refresh','lp_shout_timestamp','on_load_focus','reverse_post','lp_shout_smileys','lp_shout_bbcode';
</add before>

<edit file>
Templates\default\MyProfile.template
</edit file>

<search for>
{yabb my_extprofile}
</search for>

<add after>
{yabb my_show_shout}
</add after>

<search for>
    </tr>
{yabb my_extprofile}
</search for>

<add after>
    <tr class="windowbg">
        <td class="catbg" colspan="2"><img src="$imagesdir/profile.gif" alt="" /> <b>$shout_txt{'56'}</b></td>
    </tr><tr class="windowbg">
        <td><b>$shout_txt{'1'}</b><br /><br /></td>
        <td><input type="text" name="lp_shout_muted" size="4" value="{yabb shout_mute_days}" /><br /><br /></td>
    </tr><tr class="windowbg">
        <td><b>$shout_txt{'2'}</b><br /><br /></td>
        <td><textarea cols="50" rows="5" name="lp_shout_mute_reason">{yabb user_lp_shout_mute_reason}</textarea><br /><br /></td>
</add after>

<search for>
            <div class="contactright">
                <b>{yabb post_count}<br />{yabb post_per_day}</b> $profile_txt{'893'}
            </div>
</search for>

<add after>
            <div class="contactleft">
                <b>$shout_txt{'3'} </b>
            </div>
            <div class="contactright">
                <b>{yabb lp_shoutcount}${$uid.$user}{'lp_shoutcount'}<br />{yabb shout_per_day}$shout_per_day</b> $shout_txt{'4'}
            </div>
</add after>

<search for>

1;
</search for>

<add before>

## Shoutbox Mod ##
$mod_shoutbox = qq~<tr class="windowbg">
            <td class="catbg" colspan="2"><img src="$imagesdir/profile.gif" alt="" /> <b>$shout_txt{'56'}</b></td>
        </tr><tr class="windowbg">
            <td><b>$shout_txt{'36'}</b></td>
            <td><input type="checkbox" name="lp_shout_timestamp"{yabb lp_time_checked} /></td>
        </tr><tr class="windowbg">
            <td><b>$shout_txt{'37'}</b></td>
            <td><input type="checkbox" name="lp_shout_smileys"{yabb lp_smiley_checked} /></td>
        </tr><tr class="windowbg">
            <td><b>$shout_txt{'38'}</b></td>
            <td><input type="checkbox" name="lp_shout_bbcode"{yabb lp_bbcode_checked} /></td>
        </tr><tr class="windowbg">
            <td><b>$shout_txt{'49'}</b></td>
            <td><input type="checkbox" name="on_load_focus"{yabb on_load_focus_checked} /></td>
        </tr><tr class="windowbg">
            <td>$shout_txt{'40'}</td>
            <td><input type="checkbox" name="reverse_post"{yabb reverse_post_checked} /></td>
        </tr><tr class="windowbg">
            <td><b>$shout_txt{'39'}</b></td>
            <td><input type="text" name="lp_shout_refresh" size="3" value="{yabb lp_shout_refresh}" /></td>
        </tr>~;
</add before>

<edit file>
Templates\default\BoardIndex.template
</edit file>

<search for>
$boardhandellist = qq~
</search for>

<add before>
require "$vardir/shoutsettings.txt";

</add before>

<search for>
    $boardindex_template .= qq~
    <!-- Info Center block start -->
</search for>

<add after>
    <!-- ShoutBox Starts Here -->
    ~;

    if($enable_sb == 1) {
        $px = 'px';
        $boardindex_template .= qq~
<table>
    <tr>
        <td style="width:$shout_width$px; vertical-align:top;" id="shouttd">
            <table class="tabtitle tabtitle-text" style="width:$shout_width$px; margin-top:1em">
                <tr>
                    <td style="padding-left:1%">$name_sb</td>
                </tr>
            </table>
            <table style="width:$shout_width$px;">
                <tr>
                    <td>
                        <iframe src="./ShoutDisplay.pl" id="shouts" style="border:$sb_border_thickness $sb_border_color $sb_border_style; width:$shout_width$px" scrolling="$show_scrollbar"></iframe>
                    </td>
                </tr>
~;
        if($enable_autoscroll == 1) {
            $boardindex_template .= qq~<tr>
                    <td class="catbg center" style="height:25px">
                        <img src="$yyhtml_root/ModImages/Shoutbox/up.png" style="vertical-align: middle;" />&nbsp;<a href="#" onmouseover="scrollspeed=$speedup" onmouseout="scrollspeed=0">Scroll Shouts</a> | <a href="#" onmouseover="scrollspeed=$speeddown" onmouseout="scrollspeed=0">Scroll Shouts</a>&nbsp;<img src="$yyhtml_root/ModImages/Shoutbox/down.png" style="vertical-align: middle;" />
                    </td>
                </tr>~;
        }
        $boardindex_template .= q~
              </table>
          </td>
          <td>
~;
    }

    $boardindex_template .= qq~
<!-- ShoutBox Ends Here -->
</add after>

<search for>
    {yabb caldisplay}
<!-- ## End Event Cal ## -->
</search for>

<add after>
<!-- ShoutBox Starts Here -->
~;
if($enable_sb == 1) {
    $boardindex_template .= qq~
        </td>
    </tr>
</table>
<script type="text/javascript">
var cellOne = (document.getElementById('shouttd').offsetHeight);
var newHeight = cellOne - (35 + 25 + 90); 
if ( newHeight < 250 ) { newHeight = 250; }
document.getElementById('shouts').style.height = newHeight + 'px';  
</script> 
~;
    }
$boardindex_template .= qq~
<!-- ShoutBox Ends Here -->
</add after>

<edit file>
..\..\public_html\yabbfiles\Templates\Forum\default.css
</edit file>

<search for>
.off-color { color:#ccc;}
</search for>

<add after>
/* Start Shoutbox Mod CSS */

.shout_windowbg {
        background-color: #DEE4EC;
        padding: 3px;
        font-size: 12px;
        font-weight: normal;
        font-style: normal;
        font-family: Verdana, Sans-Serif;
        color: #000000;
}

.shout_windowbg2 {
        background-color: #FEFEFE;
        padding: 3px;
        font-size: 12px;
        font-weight: normal;
        font-style: normal;
        font-family: Verdana, Sans-Serif;
        color: #000000;
}

.tdmouseover {
        background-color: #ffff00;
        padding: 3px;
        font-size: 12px;
        font-weight: normal;
        font-style: normal;
        font-family: Verdana, Sans-Serif;
        color: #000000;
}

.shoutbox-username-style {
        color: #000000;
}

.shoutbox-post-style {
        font-size: 11px;
        font-weight: bold;
        font-style: normal;
        text-decoration: none;
        font-family: Verdana, Helvetica, Arial, Sans-Serif;
        color: #FFFFFF;
        background-color: #9CB9F3;
}

.yabb-main-contain {
        font-family: Verdana, Helvetica, Arial, sans-serif;
        font-size: 12px;
        bottom: 0px;
        padding: 0px;
        width: 75%;
        float: left;
}

.shoutbox-out-style {
        float: right;
        padding: 1px;
        z-index: 1;
        width: 24%;
}

.shoutbox-in-style {
        padding: 0px;
        background-color: #FEFEFE;
        border-width: 1px;
        border-style: solid;
        border-color: #666666;
        z-index: 2;
}

.shout_postarea {
        position : fixed;
        left: 0px;
        bottom : 0px;
        width : 100%;
        text-align : center;
        background-color : #88ACD4;
        border-top : 1px #666666 solid;
}

/* End Shoutbox Mod CSS */
</add after>